/* SerialToVM: Interface between RS-232 and SEGA Dreamcast VM */
/* several useful things needed in more than one file */

/* $Id: misc.h,v 1.4 2000/03/07 12:53:44 sgust Exp $ */

/*******************************************************************
Copyright (C) 2000 by Soeren Gust, sgust@ithh.infoserv.de

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

You can get the latest Version from http://soeren.infoserv.de
********************************************************************/

/* just easier to write */
typedef unsigned char byte;

/* errorcodes used by mid-level routines */
#define SERTOVM_OK 0		/* no error */
#define SERTOVM_TIMEOUT 1	/* timeout */
#define SERTOVM_ILLEGALREQ 2	/* can't do that */
#define SERTOVM_ABORT 3		/* got a 0x0a */
#define SERTOVM_PROTOCOLERROR 4	/* something went wrong */
#define SERTOVM_ERRNO 5		/* check errno */
#define SERTOVM_SHORT 6		/* wrong number of bytes */
#define SERTOVM_TYPE 7		/* wrong type */
#define SERTOVM_INTERNAL 8	/* code is buggy, should never happen */

/* function prototypes of mid-level routines */
int sendblock(serial_t *serial, int length, byte type, byte *buffer, int timeout);
int receiveblock(serial_t *serial, int length, int *type, byte *buffer, int timeout, int ack);

/* function prototypes of low-level routines */
int openserial(char *serialname, serial_t *serial);
int closeserial(serial_t *serial);
int readserial(serial_t *serial, int timeout);
int writeserial(serial_t *serial, byte c, int timeout);

/*#define DEBUG*/
