/* utime_amiga.c */

/* Implementation of utime() for AmigaOS on dice */

/* The version included with the dice distribution does not work correctly,
   there is a time offset involved. Instead of changing receivefile.c to handle
   this offset I decided to reimplement it correctly */

/* dice autoloads dos.library, be careful with other compilers */

/* $Id: utime_amiga.c,v 1.1 2000/03/22 18:16:20 sgust Exp $ */

/*******************************************************************
Copyright (C) 2000 by Soeren Gust, sgust@ithh.infoserv.de

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

You can get the latest Version from http://soeren.infoserv.de
********************************************************************/

/* several amiga specific includes */
#ifndef _WIN32
#include <dos/dos.h>
#include <clib/alib_protos.h>
#include <utime_amiga.h>
#else
#include "utime_amiga.h"
#endif


int utime(const char *filename, struct utimbuf *buf)
{
	struct DateStamp ds;

	/* actime: seconds since 1 Jan 1970 */
	/* Days: days since 1 Jan 1978 */
	ds.ds_Days = buf->actime / 86400 - 8 * 365 - 2;
	/* Minute: minutes since midnight */
	ds.ds_Minute = (buf->actime % 86400) / 60;
	/* Tick: 1/50 seconds since last Minute */
	ds.ds_Tick = (buf->actime % 60) * 50;
	return SetFileDate(filename, &ds);
}
